diff -Nur irc2.10.3p7/ircd/s_serv.c irc2.10.3p7+hemp2+DK+B5/ircd/s_serv.c
--- irc2.10.3p7/ircd/s_serv.c	Mon Mar  1 19:00:33 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_serv.c	Tue May 11 15:25:04 2004
@@ -2394,6 +2814,293 @@
 	return 0;
 }
 #endif
+#ifdef SERVER_MAP
+static void dump_map(sptr,root,pbuf)
+aClient *sptr;
+aClient *root;
+char *pbuf;
+{
+        Link *lp;
+        int cnt,i = 0;
+        int len;
+        int pad = 53;    /* at which position we add stats */
+        int users,max;
+        aClient *acptr;
+	
+        *pbuf= '\0';
+        strcat(pbuf,root->name);
+        len = strlen(buf);
+        buf[len] = ' ';
+        if (len < pad )
+        {
+                for (i = len+1 ; i < pad ; i++)
+                {
+                        buf[i] = '-';
+                }
+        }
+	if (IsMe(root))
+	{
+		max = istat.is_m_myclnt;
+	}
+	else
+	{
+		max = root->serv->usermax;
+	}
+        users = root->serv->usercnt[0] + root->serv->usercnt[1];
+        SPRINTF(buf + pad ," | %5d %4.1f  %5d",users,  100 * (float) users /
+                        (float) (istat.is_user[0] + istat.is_user[1]),
+                        max);
+
+	sendto_one(sptr,rpl_str(RPL_MAP,sptr->name),buf);
+	
+	i = 1;
+	if ((lp = root->serv->down))
+	{
+		cnt = lp->flags;
+		if (cnt)
+		{
+			if (pbuf > buf + 3)
+			{
+				pbuf[-2] = ' ';
+				if (pbuf[-3] == '`')
+				{
+					pbuf[-3] = ' ';
+				}
+			}
+		}
+	}
+	
+	for (; lp; lp = lp->next)
+	{
+		*pbuf = ' ';
+		if (i < cnt)
+		{
+			*(pbuf + 1) = '|';
+		}
+		else
+		{
+			*(pbuf + 1) = '`';
+		}
+
+		*(pbuf + 2) = '-';
+		*(pbuf + 3) = ' ';
+		acptr = lp->value.cptr;
+		dump_map(sptr,acptr,pbuf+4);
+		i++;
+	}
+	
+}
+/* based on ircu's m_map and kreynet's format */
+int m_map(cptr, sptr, parc, parv)
+aClient *cptr, *sptr;
+int parc;
+char    *parv[];
+{
+sendto_one(sptr,rpl_str(RPL_MAPSTART,parv[0]),"Server name","Users    %    Max");
+	dump_map(sptr,&me,buf,0);
+	sendto_one(sptr,rpl_str(RPL_MAPEND,parv[0]));
+	return 2;
+}
+#endif
+#ifdef OPER_SET
+static char *def_values[] =
+{
+	"OFF",
+	"ON",
+	NULL
+};
+static char *caccept_values[] =
+{
+	"OFF",
+	"SPLIT",
+	"ON",
+	NULL
+};
+static struct Set_Message set_msgtab[] =
+{
+	{"ACONNECT",&iconf.aconnect,def_values},
+#ifdef DELAY_ACCEPT
+	{"CACCEPT",&iconf.caccept,caccept_values},
+#endif
+	{NULL,NULL,NULL}
+};
+static void set_action(option,value)
+char *option;
+int value;
+{
+	if (!mycmp(option,"ACONNECT"))
+	{
+		if (value == 1)
+		{
+			nextconnect = timeofday;
+		}
+	}
+#ifdef DELAY_ACCEPT
+	else if (!mycmp(option,"CACCEPT"))
+	{
+		if (value == 2)
+		{
+			activate_delayed_listeners();
+		}
+	}
+#endif
+}
+int m_set(cptr, sptr, parc, parv)
+aClient *cptr, *sptr;
+int parc;
+char    *parv[];
+{
+	
+	struct Set_Message *mptr;
+	int val,i = 0;
+	char *endptr;
+	char **valstr;
+	char obuf[BUFSIZE];
+	
+	obuf[0] = 0;
+	
+	/* query for values */
+	if (parc < 2)
+	{
+		for (mptr = set_msgtab; mptr->cmd; mptr++)
+		{
+			sendto_one(sptr,":%s NOTICE %s :Value of %s is %s",ME,parv[0],
+				mptr->cmd, mptr->values[*(mptr->value)]);
+		}
+
+		return 1;
+	}
+	
+	/* query for one value */
+	if (parc == 2)
+	{
+		for (mptr = set_msgtab; mptr->cmd; mptr++)
+		{
+			if (mycmp(parv[1],mptr->cmd))
+			{
+				continue;
+			}
+			
+			sendto_one(sptr,":%s NOTICE %s :Value of %s is %s",ME,parv[0],
+				mptr->cmd, mptr->values[*(mptr->value)]);
+			return 1;
+		}
+			sendto_one(sptr,":%s NOTICE %s :Unknown option %s",ME,parv[0],parv[1]);
+
+		return 1;
+	}
+	/* setting value */	
+	for (mptr = set_msgtab; mptr->cmd; mptr++)
+	{
+		if (!mycmp(parv[1],mptr->cmd))
+		{
+			break;
+		}
+	}
+	if (!mptr->cmd)
+	{
+		sendto_one(sptr,":%s NOTICE %s :Unknown option %s",ME,parv[0],parv[1]);
+		return 1;
+	}
+	val = strtol(parv[2],&endptr,10);
+		
+	if (endptr != parv[2])
+	{
+		/* ha! a number! */
+		if (mptr->values)
+		{ /* value has symbolical names */
+			i = 0;
+			for (valstr = mptr->values; *valstr; valstr++)
+			{
+				if (i == val)
+				{
+					break;
+				}
+				strcat(obuf,*valstr);
+				strcat(obuf," ");
+				i++;
+			}
+			if (!*valstr)
+			{
+				sendto_one(sptr,":%s NOTICE %s :Uknown value %d for option %d, avaible values are %s",
+						ME,parv[0],val,mptr->cmd,obuf);
+				return 1;
+						
+			}
+			if (*(mptr->value) == i)
+			{
+				sendto_one(sptr,":%s NOTICE %s :Value of %s was already set to %s",
+					ME,parv[0],mptr->cmd,*valstr);
+				return 1;
+
+			}
+			
+			*(mptr->value) = val;
+			sendto_one(sptr,":%s NOTICE %s :Value of %s set to %s",
+					ME,parv[0],mptr->cmd,*valstr);
+			sendto_flag(SCH_NOTICE,"%s changed value of %s to %s",
+					parv[0],mptr->cmd,*valstr);
+			set_action(mptr->cmd,val);
+			return 1;
+		}
+		else
+		{ /* numeric only */
+			if (*(mptr->value) == val)
+			{
+			sendto_one(sptr, ":%s NOTICE %s :Value of %s was already set to %d",
+					ME,parv[0],mptr->cmd,val);
+
+				return 1;
+			}
+			*(mptr->value) = val;
+			sendto_one(sptr, ":%s NOTICE %s :Value of %s set to %d",
+					ME,parv[0],mptr->cmd,val);
+			sendto_flag(SCH_NOTICE,"%s changed value of %s to %d",
+					parv[0],mptr->cmd,val);
+	
+			set_action(mptr->cmd,val);
+			return 1;
+		}
+	}
+	else
+	{
+		i = 0;
+		for (valstr = mptr->values; *valstr; valstr++)
+		{
+			if (!mycmp(parv[2],*valstr))
+			{ /* found value */
+				break;	
+			}
+			i++;
+			strcat(obuf,*valstr);
+			strcat(obuf," ");
+		}
+		if (!*valstr)
+		{
+			sendto_one(sptr,":%s NOTICE %s :Unknown value for %s, avaible options are %s",
+				ME,parv[0],mptr->cmd,obuf);
+			return 1;
+		}
+		if (*(mptr->value) == i)
+		{
+			sendto_one(sptr, ":%s NOTICE %s :Value of %s was already set to %d",
+				ME,parv[0],mptr->cmd,val);
+			return 1;
+		}
+
+		*(mptr->value) = i;
+		sendto_one(sptr, ":%s NOTICE %s :Value of %s set to %s",
+			ME,parv[0],mptr->cmd,*valstr);
+		sendto_flag(SCH_NOTICE,"%s changed value of %s to %s",
+					parv[0],mptr->cmd,*valstr);
+	
+		set_action(mptr->cmd,i);
+		return 1;
+
+	}
+		
+}
+#endif
 
 /*
 ** storing server names in User structures is a real waste,
@@ -2503,6 +3210,7 @@
     return -1;
 }
 
+#ifndef DELAY_ACCEPT
 static void report_listeners(aClient *sptr, char *to)
 {
 	aConfItem *tmp;
@@ -2518,3 +3226,4 @@
 		}
 	}
 }
+#endif
diff -Nur irc2.10.3p7/ircd/s_serv_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/s_serv_ext.h
--- irc2.10.3p7/ircd/s_serv_ext.h	Wed Sep  3 19:46:04 1997
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_serv_ext.h	Tue May 11 15:25:04 2004
@@ -69,4 +69,10 @@
 #if defined(OPER_DIE) || defined(LOCOP_DIE)
 EXTERN int m_die __P((aClient *cptr, aClient *sptr, int parc, char *parv[]));
 #endif /* OPER_DIE || LOCOP_DIE */
+#ifdef SERVER_MAP
+EXTERN int m_map __P((aClient *cptr, aClient *sptr, int parc, char *parv[]));
+#endif
+#ifdef OPER_SET
+EXTERN int m_set __P((aClient *cptr, aClient *sptr, int parc, char *parv[]));
+#endif
 #undef EXTERN
diff -Nur irc2.10.3p7/ircd/s_service.c irc2.10.3p7+hemp2+DK+B5/ircd/s_service.c
--- irc2.10.3p7/ircd/s_service.c	Mon May 14 06:12:32 2001
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_service.c	Tue May 11 15:25:04 2004
@@ -440,10 +440,26 @@
 			    get_client_name(sptr, TRUE));
 		istat.is_unknown--;
 		istat.is_myservice++;
+#ifdef	EXTRA_STATISTICS
+		/*
+		**  Keep track of maximum number of simultanious
+		**  services to this server.
+		*/
+		if (istat.is_myservice > istat.is_m_myservice)
+			istat.is_m_myservice = istat.is_myservice;
+#endif
 	    }
 #endif
 
 	istat.is_service++;
+#ifdef	EXTRA_STATISTICS
+	/*
+	**  Keep track of maximum number of services
+	**  simultaniously connected to this network.
+	*/
+	if (istat.is_service > istat.is_m_service)
+		istat.is_m_service = istat.is_service;
+#endif
 	svc = make_service(sptr);
 	SetService(sptr);
 	svc->servp = sp;
diff -Nur irc2.10.3p7/ircd/s_user.c irc2.10.3p7+hemp2+DK+B5/ircd/s_user.c
--- irc2.10.3p7/ircd/s_user.c	Thu Feb 26 19:00:59 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_user.c	Tue May 11 15:25:04 2004
@@ -324,6 +324,12 @@
 		    (IsUnixSocket(cptr)) ? me.sockhost :
 		    ((cptr->hostp) ? cptr->hostp->h_name : cptr->sockhost));
 #endif
+#ifdef DELAY_CLOSE
+        if (cptr->user)
+        {
+               cptr->user->flags |= FLAGS_BADBOY;
+        }
+#endif
 	return exit_client(cptr, cptr, &me, longm);
 }
 
@@ -363,6 +369,9 @@
 #ifndef NO_PREFIX
 	char	prefix;
 #endif
+#ifdef	RESTRICT_USERNAMES
+	char	*hptr;
+#endif
 	int	i;
 
 	user->last = timeofday;
@@ -372,7 +381,6 @@
 	if (MyConnect(sptr))
 	    {
 		char *reason = NULL;
-
 #if defined(USE_IAUTH)
 		static time_t last = 0;
 		static u_int count = 0;
@@ -484,12 +492,49 @@
 
 		if (sptr->exitc == EXITC_AREF || sptr->exitc == EXITC_AREFQ)
 		    {
+			char *showres = NULL;
+			if (sptr->reason)
+			{
+				showres = strchr(sptr->reason,' ');
+				if (showres)
+				{
+					*showres = '\0';
+				}
+			}
 			if (sptr->exitc == EXITC_AREF)
-				sendto_flag(SCH_LOCAL,
-					    "Denied connection from %s.",
+			{
+				if (showres)
+				{
+					sendto_flag(SCH_LOCAL,
+					    "Denied connection from %s. (%s)",
+					    get_client_host(sptr),sptr->reason);
+					*showres = ' ';
+				}
+				else
+					sendto_flag(SCH_LOCAL,
+					    "Denied connection from %s. ",
 					    get_client_host(sptr));
-			return ereject_user(cptr, " Denied  ","Denied access");
+
+			}
+			if (showres && !*(showres+1))
+			{
+				showres = NULL;
+			}
+			return ereject_user(cptr, " Denied  ",showres ? showres+1 : "Denied access");
 		    }
+#ifdef DELAY_ACCEPT
+		/* well, this is not exactly the correct place for this
+		 * check, but oh well.. -jv */
+		{
+			aConfItem *bconf;
+			bconf = sptr->acpt->confs->value.aconf;
+			if (bconf->status & CONF_SERVERONLY)
+			{
+				sendto_flag(SCH_LOCAL,"User connection to server-only port from %s",get_client_host(sptr));
+				return ereject_user(cptr, " serveronly ", "This port is avaible for servers only.");
+			}
+		}
+#endif
 		if ((i = check_client(sptr)))
 		    {
 			struct msg_set { char *shortm; char *longm; };
@@ -514,7 +559,6 @@
 			return ereject_user(cptr, exit_msg[i].shortm,
 					    exit_msg[i].longm);
 		    }
-
 #ifndef	NO_PREFIX
 		if (IsRestricted(sptr))
 		    {
@@ -546,10 +590,32 @@
 			return exit_client(cptr, sptr, &me, "Bad Password");
 		    }
 		bzero(sptr->passwd, sizeof(sptr->passwd));
+#ifdef	RESTRICT_USERNAMES
+		/*
+		 * Do not allow special characters in the username.
+		 */
+		hptr = user->username;
+		if (prefix)
+			hptr++;
+		while (*hptr && isvaliduser(*hptr))
+			hptr++;
+		if (*hptr) {
+			ircstp->is_ref++;
+			sendto_flag(SCH_LOCAL, "Invalid username:  %s@%s.",
+				    sptr->user->username, sptr->sockhost);
+			return exit_client(cptr, sptr, &me,
+					   "Invalid username");
+		}
+#endif
 		/*
 		 * following block for the benefit of time-dependent K:-lines
 		 */
-		if (find_kill(sptr, 1, &reason))
+#ifdef ILINE_FLAGS
+		if (!IsKlineExempt(sptr) && find_kill(sptr, &reason))
+
+#else
+		if (find_kill(sptr, &reason))
+#endif
 		    {
 			/*char buf[100];*/
 
@@ -567,21 +633,21 @@
 			return exit_client(cptr, sptr, &me, (reason) ? buf :
 					   "K-lined");
 		    }
-#ifdef R_LINES
-		if (find_restrict(sptr))
-		    {
-			sendto_flag(SCH_LOCAL, "R-lined %s@%s.",
-				    user->username, sptr->sockhost);
-			ircstp->is_ref++;
-			sptr->exitc = EXITC_REF;
-# if defined(FNAME_CONNLOG) || defined(USE_SERVICES) || \
-	(defined(USE_SYSLOG) && defined(SYSLOG_CONN))
-			sendto_flog(sptr, " R lined ", user->username,
-				    user->host);
-# endif
-			return exit_client(cptr, sptr, &me , "R-lined");
-		    }
+
+#ifdef CLIENTS_CHANNEL
+		sendto_flag(SCH_CLIENTS,"Client connecting: %s is %s from %s [%s] named %s",
+				nick,user->username,user->host,
+#ifdef INET6
+                                inetntop(AF_INET6,
+                                         (char *)&sptr->ip,
+                                         mydummy, MYDUMMY_SIZE),
+#else
+                                         inetntoa((char *)&sptr->ip),
+#endif
+				
+				sptr->info);
 #endif
+
 		if (oldstatus == STAT_MASTER && MyConnect(sptr))
 			(void)m_oper(&me, sptr, 1, parv);
 /*		*user->tok = '1';
@@ -629,13 +695,76 @@
 				   (*buf) ? buf : "+", sptr->info);
 	    }	/* for(my-leaf-servers) */
 	if (IsInvisible(sptr))		/* Can be initialized in m_user() */
+	{
 		istat.is_user[1]++;	/* Local and server defaults +i */
+		user->servp->usercnt[1]++;
+	}
 	else
+	{
 		istat.is_user[0]++;
+		user->servp->usercnt[0]++;
+
+	}
+	if (istat.is_user[1] + istat.is_user[0] >= SPLIT_USERS)
+	{
+		check_split();
+	}
+#ifdef	EXTRA_STATISTICS
+	/*
+	**  Keep track of maximum number of global users.
+	*/
+	if ((istat.is_user[1] + istat.is_user[0]) > istat.is_m_users)
+	{
+		istat.is_m_users = istat.is_user[1] + istat.is_user[0];
+		if (timeofday - istat.is_m_users_t >= CLCHSEC)
+		{
+			sendto_flag(SCH_NOTICE,
+				"New highest global client connection: %d",
+				istat.is_m_users);
+			istat.is_m_users_t = timeofday;
+		}
+	}
+	if (user->servp->usercnt[0] + user->servp->usercnt[1] > user->servp->usermax)
+	{
+		user->servp->usermax = user->servp->usercnt[0] + user->servp->usercnt[1];
+	}
+#endif
 	if (MyConnect(sptr))
 	    {
 		istat.is_unknown--;
 		istat.is_myclnt++;
+#ifdef	EXTRA_STATISTICS
+		/*
+		**  Inform of highest client connection.
+		*/
+		if (istat.is_myclnt > istat.is_m_myclnt)
+		{
+			istat.is_m_myclnt = istat.is_myclnt;
+			if (timeofday - istat.is_m_myclnt_t >= CLCHSEC)
+			{
+				sendto_flag(SCH_NOTICE,
+					"New highest local client connection: %d",
+					istat.is_m_myclnt);
+				istat.is_m_myclnt_t = timeofday;
+			}
+		}
+		if ((istat.is_myclnt % CLCHNO) == 0 &&
+			istat.is_myclnt != istat.is_l_myclnt)
+		{
+			if (istat.is_l_myclnt_t == 0)
+				istat.is_l_myclnt_t = me.since;
+
+			sendto_flag(SCH_NOTICE,
+				"Local %screase from %d to %d clients "
+				"in %d seconds",
+				istat.is_myclnt > istat.is_l_myclnt ?
+				"in" : "de", istat.is_l_myclnt,
+				istat.is_myclnt,
+				timeofday - istat.is_l_myclnt_t);
+			istat.is_l_myclnt_t = timeofday;
+			istat.is_l_myclnt = istat.is_myclnt;
+		}
+#endif
 		sprintf(buf, "%s!%s@%s", nick, user->username, user->host);
 		sptr->exitc = EXITC_REG;
 		sendto_one(sptr, rpl_str(RPL_WELCOME, nick), buf);
@@ -645,13 +774,30 @@
 		sendto_one(sptr, rpl_str(RPL_CREATED, nick), creation);
 		sendto_one(sptr, rpl_str(RPL_MYINFO, parv[0]),
 			   ME, version);
+#ifdef SEND_ISUPPORT
+		sendto_one(sptr, rpl_str(RPL_ISUPPORT, parv[0]),
+				isupport);
+#endif
 		(void)m_lusers(sptr, sptr, 1, parv);
 		(void)m_motd(sptr, sptr, 1, parv);
 		if (IsRestricted(sptr))
 			sendto_one(sptr, err_str(ERR_RESTRICTED, nick));
 		send_umode(sptr, sptr, 0, ALL_UMODES, buf);
+#ifdef SPLIT_HANDLE
+		if (iconf.split)
+		{
+			sendto_one(sptr,":%s NOTICE %s :Server is currently in split-mode. You will NOT get channel operator status on new channels.",ME,nick);	
+		}
+#endif
+#ifdef DELAY_ACCEPT		
+		if (iconf.caccept < 2)
+		{
+			sendto_one(sptr,":%s NOTICE %s :Server is currently in delay-accept mode. Users can't connect.",ME,nick);
+		}
+#endif
 		nextping = timeofday;
 	    }
+
 #ifdef	USE_SERVICES
 #if 0
 	check_services_butone(SERVICE_WANT_NICK, user->server, NULL,
@@ -668,6 +814,7 @@
 		send_umode(NULL, sptr, 0, ALL_UMODES, buf);
 	check_services_num(sptr, buf);
 #endif
+	add_to_hostname_hash_table(user->host,user);
 	return 1;
     }
 
@@ -1050,6 +1197,13 @@
 		** on that channel. Propagate notice to other servers.
 		*/
 		sendto_common_channels(sptr, ":%s NICK :%s", parv[0], nick);
+#ifdef CLIENTS_CHANNEL
+		if (MyConnect(sptr) && IsRegisteredUser(sptr)) {
+			sendto_flag(SCH_CLIENTS,"Nick change %s to %s for %s from %s",
+			parv[0],nick,sptr->user->username,sptr->user->host);
+		}
+#endif
+
 		if (sptr->user) /* should always be true.. */
 		    {
 			add_history(sptr, sptr);
@@ -1403,7 +1557,7 @@
 				who_one(sptr, lp->value.cptr, chptr, lp);
 			    }
 	    }
-	else if (lp = find_user_link(chptr->members, sptr))
+	else if ((lp = find_user_link(chptr->members, sptr)))
 		who_one(sptr, lp->value.cptr, chptr, lp);
 }
 
@@ -1411,73 +1565,92 @@
 ** who_find
 **	lists all (matching) users.
 **	CPU intensive, but what can be done?
+**	
+**	Reduced CPU load - 05/2001
 */
 static	void	who_find(sptr, mask, oper)
 aClient *sptr;
 char *mask;
 int oper;
 {
-	aChannel *chptr, *ch2ptr;
-	Link	*lp;
-	int	member;
-	int	showperson, isinvis;
-	aClient	*acptr;
-
+	Reg Link	*lp,*lp2;
+	int 		myoper = 0;
+	Reg aClient	*acptr;
+	aChannel 	*chptr = NULL;	
+	if (MyConnect(sptr) && IsAnOper(sptr))
+	{
+		myoper = 1;
+	}
+	
+	/* first, show INvisible matching users on common channels */
+	for (lp = sptr->user->channel; lp ;lp = lp->next)
+	{
+		chptr = lp->value.chptr;
+		if (IsAnonymous(chptr))
+			continue;
+		for (lp2 = chptr->members; lp2 ;lp2 = lp2->next)
+		{
+			acptr = lp2->value.cptr;
+			
+			if (!IsInvisible(acptr) || (acptr->flags & FLAGS_HIDDEN))
+			{
+				continue;
+			}
+			
+			if (oper && !IsAnOper(acptr))
+			{
+				continue;
+			}
+			
+			acptr->flags |= FLAGS_HIDDEN;
+			if (!mask ||
+			     match(mask, acptr->name) == 0 ||
+			     match(mask, acptr->user->username) == 0 ||
+			     match(mask, acptr->user->host) == 0 ||
+			     match(mask, acptr->user->server) == 0 ||
+			     match(mask, acptr->info) == 0)
+				who_one(sptr, acptr, chptr, NULL);
+		
+		}
+	}
+	
+	/* second, show all matching visible clients */
 	for (acptr = client; acptr; acptr = acptr->next)
 	    {
-		ch2ptr = NULL;
 			
 		if (!IsPerson(acptr))
 			continue;
+		
+		/* clear the flag */
+		if (acptr->flags & FLAGS_HIDDEN)
+		{
+			acptr->flags &= ~FLAGS_HIDDEN;
+			continue;
+		}
+		
+		/* allow local opers to see matching clients on _LOCAL_ server */
+		if (IsInvisible(acptr) && !(MyConnect(acptr) && myoper))
+		{
+			continue;
+		}
+		/* we wanted only opers */
 		if (oper && !IsAnOper(acptr))
+		{
 			continue;
-		showperson = 0;
-		/*
-		 * Show user if they are on the same channel, or not
-		 * invisible and on a non secret channel (if any).
-		 * Do this before brute force match on all relevant
-		 * fields since these are less cpu intensive (I
-		 * hope :-) and should provide better/more shortcuts
-		 * -avalon
-		 */
-		isinvis = IsInvisible(acptr);
-		for (lp = acptr->user->channel; lp; lp = lp->next)
-		    {
-			chptr = lp->value.chptr;
-			if (IsAnonymous(chptr))
-				continue;
-			member = IsMember(sptr, chptr);
-			if (isinvis && !member)
-				continue;
-			if (member || (!isinvis && PubChannel(chptr)))
-			    {
-				showperson = 1;
-				if (!IsAnonymous(chptr) ||
-				    acptr != sptr)
-				    {
-					ch2ptr = chptr;
-					break;
-				    }
-			    }
-			if (HiddenChannel(chptr) &&
-			    !SecretChannel(chptr) && !isinvis)
-				showperson = 1;
-		    }
-		if (!acptr->user->channel && !isinvis)
-			showperson = 1;
+		}
+
 		/*
-		** This is brute force solution, not efficient...? ;( 
+		** This is brute force solution, not efficient...? ;(
 		** Show entry, if no mask or any of the fields match
 		** the mask. --msa
 		*/
-		if (showperson &&
-		    (!mask ||
+		if (!mask ||
 		     match(mask, acptr->name) == 0 ||
 		     match(mask, acptr->user->username) == 0 ||
 		     match(mask, acptr->user->host) == 0 ||
 		     match(mask, acptr->user->server) == 0 ||
-		     match(mask, acptr->info) == 0))
-			who_one(sptr, acptr, ch2ptr, NULL);
+		     match(mask, acptr->info) == 0)
+			who_one(sptr, acptr, NULL, NULL);
 	    }
 }
 
@@ -1511,7 +1684,7 @@
 	for (p = NULL, mask = strtoken(&p, parv[1], ",");
 	    mask && penalty <= MAXPENALTY;
 		mask = strtoken(&p, NULL, ","))
-	{ 
+	{
 		channame = NULL;
 		penalty += 1;
 
@@ -1523,12 +1696,11 @@
 		/* I think it's useless --Beeth */
 		clean_channelname(mask);
 #endif
-
 		/* simplify mask */
 		(void)collapse(mask);
 
 		/*
-		** We can never have here !mask 
+		** We can never have here !mask
 		** or *mask == '\0', since it would be equal
 		** to parc == 1, that is 'WHO' and/or would not
 		** pass through above for loop.
@@ -1603,6 +1775,7 @@
 				** All nice chances lost above. 
 				** We must hog our server with that.
 				*/
+				
 				who_find(sptr, mask, oper);
 				penalty += MAXPENALTY;
 			}
@@ -1695,7 +1868,11 @@
 
 	if (acptr->user && MyConnect(acptr))
 		sendto_one(sptr, rpl_str(RPL_WHOISIDLE, sptr->name),
+#ifdef WHOIS_SIGNON_TIME
+			   name, timeofday - user->last,acptr->firsttime);
+#else
 			   name, timeofday - user->last);
+#endif
 }
 
 /*
@@ -2336,10 +2513,35 @@
 	cptr->flags &= ~FLAGS_PINGSENT;
 	sptr->flags &= ~FLAGS_PINGSENT;
 
-	if (!BadPtr(destination) && mycmp(destination, ME) != 0)
+#ifdef SPLIT_HANDLE
+	if (IsServer(cptr) && IsServer(sptr) && (BadPtr(destination) || !match(destination,ME)))
+	{
+		if (IsBurst(sptr))
+		{
+			ClearBurst(sptr);
+			istat.is_eobservers++;
+			if (MyConnect(sptr))
+			{
+				sendto_flag(SCH_NOTICE,"End of burst from %s. Lasted %d seconds.",
+					cptr->name,timeofday - cptr->firsttime);
+			}
+			else
+			{
+				sendto_flag(SCH_DEBUG,"EOB from %s (PONG)",sptr->name);
+			}
+			bubble_eob(sptr);
+			if (iconf.split)
+			{
+				check_split();
+			}
+		}
+	}
+#endif
+	if (!BadPtr(destination) && match(destination, ME) != 0)
 	    {
 		if ((acptr = find_client(destination, NULL)) ||
-		    (acptr = find_server(destination, NULL))) {
+		    (acptr = find_server(destination, NULL))) 
+		{
 			if (!(MyClient(sptr) && mycmp(origin, sptr->name)))
 				sendto_one(acptr,":%s PONG %s %s",
 					   parv[0], origin, destination);
@@ -2508,12 +2710,60 @@
 				      parv[0], IsOper(sptr) ? 'o' : 'O');
 #endif
 		if (IsAnOper(sptr))
+		{
 			istat.is_oper++;
+			sptr->user->servp->usercnt[2]++;
+		}
 	    }
 	else
 	    {
 		(void)detach_conf(sptr, aconf);
 		sendto_one(sptr,err_str(ERR_PASSWDMISMATCH, parv[0]));
+#ifdef FAILED_OPERLOG
+              sendto_flag(SCH_NOTICE, "FAILED OPER %s attempt by %s!%s@%s",
+                          name, parv[0], sptr->user->username, sptr->user->host);
+#     if defined(USE_SYSLOG) && defined(SYSLOG_OPER)
+              syslog(LOG_INFO, "FAILED OPER %s attempt by %s!%s@%s [%s@%s]",
+                          name, parv[0], sptr->user->username, sptr->user->host,
+                          sptr->auth, IsUnixSocket(sptr) ?  sptr->sockhost :
+#ifdef INET6
+                          inet_ntop(AF_INET6, (char *)&sptr->ip, mydummy, MYDUMMY_SIZE));
+#else
+
+                          inetntoa((char *)&sptr->ip));
+#endif
+#     endif
+#     ifdef FNAME_OPERLOG
+            {
+              int     logfile;
+
+              (void)alarm(3);
+              if (IsPerson(sptr) &&
+                  (logfile = open(FNAME_OPERLOG, O_WRONLY|O_APPEND)) != -1)
+              {
+                (void)alarm(0);
+                SPRINTF(buf, "%s FAILED OPER %s attempt by %s!%s@%s [%s@%s]\n",
+                         myctime(timeofday), name, parv[0], sptr->user->username,
+                         sptr->user->host, sptr->auth, IsUnixSocket(sptr) ?
+                         sptr->sockhost :
+#ifdef INET6
+                         inetntop(AF_INET6, (char *)&sptr->ip, mydummy,
+                                  MYDUMMY_SIZE)
+
+#else
+                         inetntoa((char *)&sptr->ip)
+#endif
+			 );
+              (void)alarm(3);
+              (void)write(logfile, buf, strlen(buf));
+              (void)alarm(0);
+              (void)close(logfile);
+         }
+         (void)alarm(0);
+           }
+#     endif
+#endif
+
 	    }
 	return 3;
     }
@@ -2834,11 +3084,15 @@
 		    {
 			istat.is_user[1]--;
 			istat.is_user[0]++;
+			sptr->user->servp->usercnt[1]--;
+			sptr->user->servp->usercnt[0]++;
 		    }
 		if (IsInvisible(sptr) && !(setflags & FLAGS_INVISIBLE))
 		    {
 			istat.is_user[1]++;
 			istat.is_user[0]--;
+			sptr->user->servp->usercnt[1]++;
+			sptr->user->servp->usercnt[0]--;
 		    }
 		send_umode_out(cptr, sptr, setflags);
 	    }
@@ -2847,6 +3101,7 @@
 	if (IsOper(sptr) && !(setflags & FLAGS_OPER))
 	    {
 		istat.is_oper++;
+		sptr->user->servp->usercnt[2]++;
 #ifdef	USE_SERVICES
 		check_services_butone(SERVICE_WANT_OPER, sptr->user->server, 
 				      sptr, ":%s MODE %s :+o", parv[0],
@@ -2856,6 +3111,7 @@
 	else if (!IsOper(sptr) && (setflags & FLAGS_OPER))
 	    {
 		istat.is_oper--;
+		sptr->user->servp->usercnt[2]--;
 #ifdef	USE_SERVICES
 		check_services_butone(SERVICE_WANT_OPER, sptr->user->server,
 				      sptr, ":%s MODE %s :-o", parv[0],
@@ -2865,6 +3121,7 @@
 	else if (MyConnect(sptr) && !IsLocOp(sptr) && (setflags & FLAGS_LOCOP))
 	    {
 		istat.is_oper--;
+		sptr->user->servp->usercnt[2]--;
 #ifdef USE_SERVICES
 		check_services_butone(SERVICE_WANT_OPER, sptr->user->server,
 				      sptr, ":%s MODE %s :-O", parv[0],     
diff -Nur irc2.10.3p7/ircd/version.c.SH.in irc2.10.3p7+hemp2+DK+B5/ircd/version.c.SH.in
--- irc2.10.3p7/ircd/version.c.SH.in	Thu Jul 22 00:59:54 1999
+++ irc2.10.3p7+hemp2+DK+B5/ircd/version.c.SH.in	Tue May 11 15:25:04 2004
@@ -63,6 +63,7 @@
 char *generation = "$generation";
 char *creation = "$creation";
 char *version;				/* Filled by make_version() */
+char *isupport;			/* Filled by make_isupport() */
 char *pass_version = PATCHLEVEL;
 
 char *infotext[] =
@@ -108,6 +109,9 @@
 	"",
 	"[$sumsserv] [$sumchan] [$sumsbsd] [$sumsuser]",
 	"[$sumhash] [$sumsmisc] [$sumircd]",
+	"",
+	"This server has been patched by hemp2 patch, revision 2004022701.",
+	"See http://jv.irc.cz/irc/ for more information about this patch.",
 	0,
     };
 !SUB!THIS!
diff -Nur irc2.10.3p7/ircd/version_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/version_ext.h
--- irc2.10.3p7/ircd/version_ext.h	Wed Sep  3 19:46:08 1997
+++ irc2.10.3p7+hemp2+DK+B5/ircd/version_ext.h	Tue May 11 15:25:04 2004
@@ -27,6 +27,7 @@
 extern char *generation;
 extern char *creation;
 extern char *version;
+extern char *isupport;
 extern char *pass_version;
 extern char *infotext[];
 #endif /* VERSION_C */
